3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE
='[--signoff] [--dotest=<dir>] [--keep] [--utf8 | --no-utf8]
6 [--3way] [--interactive] [--binary]
7 [--whitespace=<option>] [-C<n>] [-p<n>]
9 or, when resuming [--skip | --resolved]'
14 git var GIT_COMMITTER_IDENT
>/dev
/null ||
exit
17 echo "$1" >"$dotest/next"
21 stop_here_user_resolve
() {
22 if [ -n "$resolvemsg" ]; then
23 printf '%s\n' "$resolvemsg"
26 cmdline
=$
(basename $0)
27 if test '' != "$interactive"
31 if test '' != "$threeway"
35 if test '.dotest' != "$dotest"
37 cmdline
="$cmdline -d=$dotest"
39 echo "When you have resolved this problem run \"$cmdline --resolved\"."
40 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
46 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
47 "$dotest/patch" "$dotest/info"
48 echo "$next" >"$dotest/next"
54 echo "Cannot fall back to three-way merge."
59 O_OBJECT
=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
61 rm -fr "$dotest"/patch-merge-
*
62 mkdir
"$dotest/patch-merge-tmp-dir"
64 # First see if the patch records the index info that we can use.
65 git apply
--build-fake-ancestor "$dotest/patch-merge-tmp-index" \
67 GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
68 git write-tree
>"$dotest/patch-merge-base+" ||
69 cannot_fallback
"Repository lacks necessary blobs to fall back on 3-way merge."
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
73 git apply
$binary --cached <"$dotest/patch"
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
78 cannot_fallback
"Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
82 test -f "$dotest/patch-merge-index" &&
83 his_tree
=$
(GIT_INDEX_FILE
="$dotest/patch-merge-index" git write-tree
) &&
84 orig_tree
=$
(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-
* ||
exit 1
87 echo Falling back to patching base and
3-way merge...
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
95 eval GITHEAD_
$his_tree='"$SUBJECT"'
96 export GITHEAD_
$his_tree
97 git-merge-recursive
$orig_tree -- HEAD
$his_tree ||
{
99 echo Failed to merge
in the changes.
102 unset GITHEAD_
$his_tree
106 dotest
=.dotest sign
= utf8
=t keep
= skip
= interactive
= resolved
= binary
=
113 -d=*|
--d=*|
--do=*|
--dot=*|
--dote=*|
--dotes=*|
--dotest=*)
114 dotest
=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
115 -d|
--d|
--do|
--dot|
--dote|
--dotes|
--dotest)
116 case "$#" in 1) usage
;; esac; shift
119 -i|
--i|
--in|
--int|
--inte|
--inter|
--intera|
--interac|
--interact|\
120 --interacti|
--interactiv|
--interactive)
121 interactive
=t
; shift ;;
123 -b|
--b|
--bi|
--bin|
--bina|
--binar|
--binary)
126 -3|
--3|
--3w|
--3wa|
--3way)
128 -s|
--s|
--si|
--sig|
--sign|
--signo|
--signof|
--signoff)
130 -u|
--u|
--ut|
--utf|
--utf8)
131 utf8
=t
; shift ;; # this is now default
132 --no-u|
--no-ut|
--no-utf|
--no-utf8)
134 -k|
--k|
--ke|
--kee|
--keep)
137 -r|
--r|
--re|
--res|
--reso|
--resol|
--resolv|
--resolve|
--resolved)
143 --whitespace=*|
-C*|
-p*)
144 git_apply_opt
="$git_apply_opt $1"; shift ;;
147 resolvemsg
=${1#--resolvemsg=}; shift ;;
158 # If the dotest directory exists, but we have finished applying all the
159 # patches in them, clear it out.
160 if test -d "$dotest" &&
161 last
=$
(cat "$dotest/last") &&
162 next
=$
(cat "$dotest/next") &&
164 test "$next" -gt "$last"
171 case "$#,$skip$resolved" in
173 # Explicit resume command and we do not have file, so
177 # No file input but without resume parameters; catch
178 # user error to feed us a patch from standard input
179 # when there is already .dotest. This is somewhat
180 # unreliable -- stdin could be /dev/null for example
181 # and the caller did not intend to feed us a patch but
182 # wanted to continue unattended.
189 die
"previous dotest directory $dotest still exists but mbox given."
192 # Make sure we are not given --skip nor --resolved
193 test ",$skip,$resolved," = ,,, ||
194 die
"Resolve operation not in progress, we are not resuming."
197 mkdir
-p "$dotest" ||
exit
199 git mailsplit
-d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
{
204 # -b, -s, -u, -k and --whitespace flags are kept for the
205 # resuming session after a patch failure.
206 # -3 and -i can and must be given when resuming.
207 echo "$binary" >"$dotest/binary"
208 echo " $ws" >"$dotest/whitespace"
209 echo "$sign" >"$dotest/sign"
210 echo "$utf8" >"$dotest/utf8"
211 echo "$keep" >"$dotest/keep"
212 echo 1 >"$dotest/next"
217 files
=$
(git diff-index
--cached --name-only HEAD
) ||
exit
218 if [ "$files" ]; then
219 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
224 if test "$(cat "$dotest/binary
")" = t
226 binary
=--allow-binary-replacement
228 if test "$(cat "$dotest/utf8
")" = t
234 if test "$(cat "$dotest/keep
")" = t
238 ws
=`cat "$dotest/whitespace"`
239 if test "$(cat "$dotest/sign
")" = t
241 SIGNOFF
=`git-var GIT_COMMITTER_IDENT | sed -e '
243 s/^/Signed-off-by: /'
249 last
=`cat "$dotest/last"`
250 this
=`cat "$dotest/next"`
254 this
=`expr "$this" + 1`
258 if test "$this" -gt "$last"
265 while test "$this" -le "$last"
267 msgnum
=`printf "%0${prec}d" $this`
268 next
=`expr "$this" + 1`
269 test -f "$dotest/$msgnum" ||
{
275 # If we are not resuming, parse and extract the patch information
276 # into separate files:
277 # - info records the authorship and title
278 # - msg is the rest of commit log message
279 # - patch is the patch body.
281 # When we are resuming, these files are either already prepared
282 # by the user, or the user can tell us to do so by --resolved flag.
285 git mailinfo
$keep $utf8 "$dotest/msg" "$dotest/patch" \
286 <"$dotest/$msgnum" >"$dotest/info" ||
289 # skip pine's internal folder data
290 grep '^Author: Mail System Internal Data$' \
291 <"$dotest"/info
>/dev
/null
&&
294 test -s $dotest/patch ||
{
295 echo "Patch is empty. Was it split wrong?"
298 git stripspace
< "$dotest/msg" > "$dotest/msg-clean"
302 GIT_AUTHOR_NAME
="$(sed -n '/^Author/ s/Author: //p' "$dotest/info
")"
303 GIT_AUTHOR_EMAIL
="$(sed -n '/^Email/ s/Email: //p' "$dotest/info
")"
304 GIT_AUTHOR_DATE
="$(sed -n '/^Date/ s/Date: //p' "$dotest/info
")"
306 if test -z "$GIT_AUTHOR_EMAIL"
308 echo "Patch does not have a valid e-mail address."
312 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
314 SUBJECT
="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info
")"
315 case "$keep_subject" in -k) SUBJECT
="[PATCH] $SUBJECT" ;; esac
319 if test '' != "$SIGNOFF"
322 sed -ne '/^Signed-off-by: /p' \
323 "$dotest/msg-clean" |
327 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
328 test '' = "$LAST_SIGNED_OFF_BY" && echo
335 printf '%s\n' "$SUBJECT"
336 if test -s "$dotest/msg-clean"
339 cat "$dotest/msg-clean"
341 if test '' != "$ADD_SIGNOFF"
345 } >"$dotest/final-commit"
348 case "$resolved$interactive" in
350 # This is used only for interactive view option.
351 git diff-index
-p --cached HEAD
>"$dotest/patch"
357 if test "$interactive" = t
360 die
"cannot be interactive without stdin connected to a terminal."
362 while test "$action" = again
364 echo "Commit Body is:"
365 echo "--------------------------"
366 cat "$dotest/final-commit"
367 echo "--------------------------"
368 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
372 [aA
]*) action
=yes interactive
= ;;
373 [nN
]*) action
=skip
;;
374 [eE
]*) git_editor
"$dotest/final-commit"
377 LESS
=-S ${PAGER:-less} "$dotest/patch" ;;
385 if test $action = skip
391 if test -x "$GIT_DIR"/hooks
/applypatch-msg
393 "$GIT_DIR"/hooks
/applypatch-msg
"$dotest/final-commit" ||
398 printf 'Applying %s\n' "$SUBJECT"
403 git apply
$git_apply_opt $binary --index "$dotest/patch"
407 # Resolved means the user did all the hard work, and
408 # we do not have to do any patch application. Just
409 # trust what the user has in the index file and the
412 git diff-index
--quiet --cached HEAD
&& {
413 echo "No changes - did you forget to use 'git add'?"
414 stop_here_user_resolve
$this
416 unmerged
=$
(git ls-files
-u)
417 if test -n "$unmerged"
419 echo "You still have unmerged paths in your index"
420 echo "did you forget to use 'git add'?"
421 stop_here_user_resolve
$this
428 if test $apply_status = 1 && test "$threeway" = t
432 # Applying the patch to an earlier tree and merging the
433 # result may have produced the same tree as ours.
434 git diff-index
--quiet --cached HEAD
&& {
435 echo No changes
-- Patch already applied.
439 # clear apply_status -- we have successfully merged.
443 if test $apply_status != 0
445 echo Patch failed
at $msgnum.
446 stop_here_user_resolve
$this
449 if test -x "$GIT_DIR"/hooks
/pre-applypatch
451 "$GIT_DIR"/hooks
/pre-applypatch || stop_here
$this
454 tree
=$
(git write-tree
) &&
455 echo Wrote tree
$tree &&
456 parent
=$
(git rev-parse
--verify HEAD
) &&
457 commit
=$
(git commit-tree
$tree -p $parent <"$dotest/final-commit") &&
458 echo Committed
: $commit &&
459 git update-ref
-m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD
$commit $parent ||
462 if test -x "$GIT_DIR"/hooks
/post-applypatch
464 "$GIT_DIR"/hooks
/post-applypatch